﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

public class ObjectAddress
{
    public static int GCCount 
    { 
        get
        {
            return GC.CollectionCount(0);
        }
    }

    internal unsafe static KeyValuePair<IntPtr, int> GetAddress(object o)
    {
        int gcCount = GC.CollectionCount(0);

        TypedReference tr = __makeref(o);
        IntPtr ptr = **(IntPtr**)(&tr);

        return new KeyValuePair<IntPtr, int>(ptr, gcCount);
    }
}

public class CrossDomainData
{
    public List<int> Input;

    int _aggregate;

    public int Aggregate
    {
        get
        {
            return _aggregate;
        }
        set
        {
            _aggregate = value;
        }
    }
}